The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::SingWave Class Reference

STK "singing" looped soundfile class. More...

`#include <SingWave.h>`

Inheritance diagram for stk::SingWave:

## Public Member Functions
| SingWave (std::string fileName, bool raw=false)
| Class constructor taking filename argument.
| ~SingWave (void)
| Class destructor.
void | reset (void)
| Reset file to beginning.
void | normalize (void)
| Normalize the file to a maximum of +-1.0.
void | normalize (StkFloat peak)
| Normalize the file to a maximum of +- peak.
void | setFrequency (StkFloat frequency)
| Set looping parameters for a particular frequency.
void | setVibratoRate (StkFloat rate)
| Set the vibrato frequency in Hz.
void | setVibratoGain (StkFloat gain)
| Set the vibrato gain.
void | setRandomGain (StkFloat gain)
| Set the random-ness amount.
void | setSweepRate (StkFloat rate)
| Set the sweep rate.
void | setGainRate (StkFloat rate)
| Set the gain rate.
void | setGainTarget (StkFloat target)
| Set the gain target value.
void | noteOn (void)
| Start a note.
void | noteOff (void)
| Stop a note.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK "singing" looped soundfile class.

This class loops a specified soundfile and modulates it both periodically and randomly to produce a pitched musical sound, like a simple voice or violin. In general, it is not be used alone because of "munchkinification" effects from pitch shifting. Within STK, it is used as an excitation source for other instruments.

by Perry R. Cook and Gary P. Scavone, 1995–2021.

## Constructor & Destructor Documentation

## ◆ SingWave()

stk::SingWave::SingWave | ( | std::string | fileName,
|  | bool | raw = `false`
| ) |  |

Class constructor taking filename argument.

An StkError will be thrown if the file is not found, its format is unknown, or a read error occurs. If the soundfile has no header, the second argument should be true and the file data will be assumed to consist of 16-bit signed integers in big-endian byte order at a sample rate of 22050 Hz.

## Member Function Documentation

## ◆ tick()

StkFrames & stk::SingWave::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

118{
119#if defined(_STK_DEBUG_)
120 if ( channel >= frames.channels() ) {
121 oStream_ << "SingWave::tick(): channel and StkFrames arguments are incompatible!";
122 handleError( StkError::FUNCTION_ARGUMENT );
123 }
124#endif
125
126 StkFloat *samples = &frames[channel];
127 unsigned int hop = frames.channels();
128 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
129 *samples = SingWave::tick();
130
131 return frames;
132}
stk::SingWave::tick
StkFloat tick(void)
Compute and return one output sample.
Definition: SingWave.h:104
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- SingWave.h

The Synthesis ToolKit in C++ (STK)
©1995--2021 Perry R. Cook and Gary P. Scavone. All Rights Reserved.